#ifndef MTALIB_H
#define MTALIB_H

#define MTA_DEFAULT_CONFIGFILE "/etc/mtalib.conf"
#ifndef P__
#define P__(x) x
#endif

typedef enum { MTA_SUCCESS, MTA_DEFER, MTA_FATAL } mta_ret_t;

typedef struct mta_t {
	/* priv */ mta_ret_t (*mta_open)P__((struct mta_t **, const char *path,const char *from, const char *to));
	/* pub  */ mta_ret_t (*mta_write)P__((struct mta_t *,const char *,size_t l));
	/* pub  */ mta_ret_t (*mta_abort)P__((struct mta_t *));
	/* pub  */ mta_ret_t (*mta_close)P__((struct mta_t *));
	/* priv */ void *priv;
} mta_t;

int mta_init P__((void));
char *mta_select P__((const char *configfile_or_NULL_for_default));
mta_ret_t mta_start P__((mta_t **,const char *mta_name, const char *from, const char *to));
extern const char *mta_errtxt;
extern const char *mta_hcmssc;
void mta_set_err P__((const char *txt,const char *txt2, const char *hcm, int err)); /* errno or 0 */

extern char *mta_hostname;
mta_ret_t mta_set_hostname P__((const char *)); /* NULL: use gethostname */


extern mta_t mta_qq;
extern mta_t mta_sm;
extern mta_t mta_maildir;
extern mta_t mta_inews;
extern mta_t mta_dummy;

#endif
